% SIMULATES AN AR(1)PROCESS
% VIvaldo M. Mendes, ISCTE - Lisbon University Institute, January 2009


% initial conditions

y(1)=0; epsilon(1)=1; 

% sett6ing the number of iterations and the values of the autoregressive parameter

N=30;  a=0; 

%Defining the function for the initial period (1)

x(1)=a*y(1)+epsilon(1); epsilon=0;

% The routine for all subsequent periods (1+i)

for i=1:N
    x(i+1)=a*x(i)+epsilon;
end

figure
plot(x,'b');
title('Impulse response AR(1)')
axis([0,30,-0.10,1.4])
text(2.2,0.08,'a=0')
hold on

% Using various other different values for parameter "a"

a=0.5; 
for i=1:N
    x(i+1)=a*x(i)+epsilon;
end
hold on
plot(x,'r');
text(5,0.2,'a=0.5')

a=0.9; 
for i=1:N
    x(i+1)=a*x(i)+epsilon;
end
hold on
plot(x,'c')
text(16,0.3,'a=0.9')

a=0.99; 
for i=1:N
    x(i+1)=a*x(i)+epsilon;
end
hold on
plot(x,'-b')
text(22,0.85,'a=0.99')
 
 a=1.0; 
for i=1:N
    x(i+1)=a*x(i)+epsilon;
end
hold on
plot(x,'.g')
text(25,1.05,'a=1')

 a=1.01; 
for i=1:N
    x(i+1)=a*x(i)+epsilon;
end
hold on
plot(x,'.r')
text(20,1.3,'a=1.01')

hold off


    