% Routine to obtain a linear trend with and without breaks
%Vivaldo M. Mendes, ISCTE - Lisbon University Institute, January 2009

%Requires a file with a time series
%Requires the file "trend.m"

%Loading data
load USdata.txt;
time=1947.0:0.25:2008.50;

%A linear trend without breaks
%Make two figures: original data vs the trend, and the cyclical component
y = trend(USdata(:,7),'linear');
figure; 
subplot(211);plot(time',y,'r'); 
hold on; 
plot(time',USdata(:,7));

%The cyclical component
subplot(212);
plot(time,USdata(:,7)-y)


%A linear trend with breaks
%Make two figures: original data vs the trend, and the cyclical component
%the breaks are assumed to occur at time=108 and time=170

y1 = trend(USdata(:,7),'linear',[108,170]);
figure;
subplot(211);
plot(time',y1,'r'); 
hold on; 
plot(time(108),y1(108),'o'); 
plot(time(170),y1(170),'o');
plot(time',USdata(:,7));

%The cyclical component

subplot(212);
plot(time',USdata(:,7)-y1)