
%Calculates the coefficients of autocorrelation and crosscorrelation
%Vivaldo M. Mendes, ISCTE-Lisbon University Institute, January 2009

%Requires hpfilter.m
%Requires USdata.txt


%Load tyhe data file
load USdata.txt;


%Defining the variables which we are going to work with (x,y,w) and (g1,g2,g3)
[g1] = hpfilter(USdata(:,7),1600,[]);
[g2] = hpfilter(USdata(:,10),1600,[]);
[g3] = hpfilter(USdata(:,8),1600,[]);

x=USdata(:,7)-g1;
y=USdata(:,10)-g2;
w=USdata(:,8)-g3;

%Use the "cra" built in function in Matlab
%The synthax of the "cra" function looks like this:
    %cra(data);
    %[ir,R,cl] = cra(data,M,na,plot);
    %cra(R);
%Define the "data" (vectors of correlation and crosscorrelation: z1,z2,z3)

z1=[x x];
z2=[x y];
z3=[x w];

%Set the timelag considered: 10 periods (M=10 in the entries of "cra"
%Set na=0 and plot=0 (for further details search in the help menu of Matlab for "cra"

[ir1,r1,cl1]=cra(z1,10,0,0);
corrcoefGDP=r1(:,4)
[ir2,r2,cl2]=cra(z2,10,0,0);
corrcoefGDPInvest=r2(:,4)
[ir3,r3,cl3]=cra(z3,10,0,0);
corrcoefGDPRubish=r3(:,4)
%corrcoefGDPInvest=r2(:,4) tells us that the coefficent is given by column "4" of the file "r2" saved in the Workspace

%Make figure

figure(1);
subplot(131);
plot(-10:10,r1(:,4),'o')
subplot(132);
plot(-10:10,r2(:,4),'or')
subplot(133);
plot(-10:10,r3(:,4),'og')



