% Calculates the Hodrick-Prescott filter (the trend) and the short term business cycle component
% Vivaldo M. Mendes, ISCTE-Lisbon University Institute, January 2009

% Requires: hpfilter.m 
% Requires: penta2.m
% lambda= Smoothing parameter (monthly: 14400, quarterly: 1600, year: 7)
% requires a time series (in this case, the data is "USdata.txt")

clear;clc;

% load data and fix the range and frequency of the time series
load USdata.txt;
time=1947:0.25:2008.50;

% make separate figures: hp trend against the original data, and the short term cyclical component
% for colum 7 of the USdata.txt
figure
[HpGDP] = hpfilter(USdata(:,7),1600);
plot(time',HpGDP,'r'); hold on; plot(time',USdata(:,7));
ResGDP=USdata(:,7)-HpGDP;
figure;plot(time',ResGDP)

%Puts the two previous figures in just one plot with two yy axis
figure
plotyy(time',USdata(:,7),time',USdata(:,7)-HpGDP); hold on; plot(time',HpGDP,'r');

% repeats the previous steps, but now for column 10 of USdata.txt
figure
[HpRINV] = hpfilter(USdata(:,10),1600);
plot(time',HpRINV,'r'); hold on; plot(time',USdata(:,10));
ResRINV=USdata(:,10)-HpRINV;
figure;plot(time',ResRINV)

figure
plotyy(time',USdata(:,10),time',USdata(:,10)-HpRINV); hold on; plot(time',HpRINV,'r');

% we will get 6 figures alltogether